#define PI 3.14159
#include <time.h>
#include "figure.h"
#define randangle 0.05-float(random(1000))/float(10000);

Figure::Figure(float x, float y, TColor cc, int f)
{
  //    
  xc=x;
  yc=y;
  b=c=0;
  a=3*PI;
  da=db=dc=0.05;
  col=cc;
  fi=f;
  mx=my=1;
  gx=random(15)+5;
}

void Figure::Draw(int i, float x,float y,float z, float x0, float y0, TDC &ddb)
//    
{
  float  y1, z1;
  //    
  y1=cos(c)*(x*sin(a)+y*cos(a))-sin(c)*(sin(b)*(x*cos(a)-y*sin(a))+z*cos(b));
  z1=sin(c)*(x*sin(a)+y*cos(a))+cos(c)*(sin(b)*(x*cos(a)-y*sin(a))+z*cos(b));
	 if ((y==-3 && i) || (x==-3 && !i)) ddb.MoveTo(x0+int(y1*gx), y0-int(z1*gx));
				else ddb.LineTo(x0+int(y1*gx), y0-int(z1*gx));
}

void Figure::Drawer(int i, float x0, float y0, TDC& ddb)
//  
{
		float x, y, z;
		x=-3;
		//  
		do
		{
		  y=-3;
		  do
		  {
			 z=float(i)*sqrt(18-x*x-y*y); // 
			 Draw(1, x, y, z, x0, y0, ddb);
			 y++;
		  } while (y<=3);
		  x++;
		}
		while (x<=3);
		y=-3;
		//  
		do
		{
		  x=-3;
		  do
		  {
			 z=float(i)*sqrt(18-x*x-y*y);
			 Draw(0, x, y, z, x0, y0, ddb);
			 x++;
		  } while (x<=3);
		  y++;
		}
		while (y<=3);
}

void Figure::Saver(TDC &ddb)
{
		TPen pen(col, 1, PS_SOLID);//   
		ddb.SelectObject(pen);// 

		Drawer(1, xc, yc, ddb); //   
		Drawer(-1, xc, yc, ddb);//  

		TRect ss = ddb.GetClipBox(); //    
		TSize sz = ss.Size(); //   

		randomize();

		if(a<=2*PI) a+=da; else a=0; //
		if(b<=2*PI) b+=db; else b=0; //  
		if(c<=2*PI) c+=dc; else c=0; //

		xc+=float(mx)*6*cos(fi*PI/180); //  
		yc+=float(my)*6*sin(fi*PI/180); // 

		if (fabs(xc)<gx*5 || fabs(xc-sz.cx)<gx*5) 
		//    /  
		{
		  mx*=-1; //    
		  da=randangle; //
		  db=randangle; //    
		  dc=randangle; //
		}
		else if (fabs(yc)<gx*5 || fabs(yc-sz.cy)<gx*5)
		//    /  
		{
		  my*=-1; //    
		  da=randangle; //
		  db=randangle; //    
		  dc=randangle; //
		}
}
