#include "tdlg.h"

DEFINE_RESPONSE_TABLE1 (TDlg, TDialog)
  EV_COMMAND (IDOK, CmOk),
END_RESPONSE_TABLE;

TDlg::TDlg (TWindow *parent, TResId resId):
		TDialog (parent, resId)
{
  listbox = new TListBox (this, IDC_LISTBOX1); // -
  checkbox = new TCheckBox(this, IDC_CHECKBOX); // -
  TransferBuffer = &Buf; //      
}

void  TDlg::SetupWindow() //,       
{
  TDialog::SetupWindow(); 
  Buf.lbData.AddString("1"); // 
  Buf.lbData.AddString("2"); // 
  Buf.lbData.AddString("3"); //
  Buf.lbData.AddString("5"); //
  Buf.lbData.AddString("10");//   
  Buf.lbData.AddString("15");//
  Buf.lbData.AddString("20");//
  Buf.lbData.AddString("40");//
  TransferData(tdSetData);  //       
  HKEY res; //  
  DWORD disp, sizestr=3, sizemode=1; 
  char mode=0; //   
  if(RegCreateKeyEx(HKEY_CURRENT_USER, "Software\\FigureScreenSaver\\", 0,
					  NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS,
					  NULL, &res, &disp)==ERROR_SUCCESS)
  // /   windows 
{
	 if (disp==REG_CREATED_NEW_KEY) //   
	 //          
	 {
		RegSetValueEx(res,"Number",0, REG_SZ,(BYTE*)"20",3); 
		RegSetValueEx(res,"Mode",0, REG_BINARY, (BYTE*)&mode, 1);
		listbox->SetSelIndex(6); //     20 
	 }
	 else //   
	 {
		char numb[3]; 
		//      
		RegQueryValueEx(res, "Number", 0, NULL, (BYTE*)numb, &sizestr);
		listbox->SetSelString(numb, -1);//  
		//       
		RegQueryValueEx(res, "Mode", 0, NULL, (BYTE*)&mode, &sizemode);
		//       
		checkbox->SetCheck(mode? BF_CHECKED: BF_UNCHECKED);
	 }
	 RegCloseKey(res); //   
  }
  //      ,     
  else listbox->SetSelIndex(6); 
}

void TDlg::CmOk()
{
  TransferData(tdGetData); //     
  HKEY res;
  Buf.lbData.GetSelString(LBStrg, sizeof(LBStrg));//  
  char mode=Buf.check? 1: 0;//  
  ///  
  if(RegCreateKeyEx(HKEY_CURRENT_USER, "Software\\FigureScreenSaver\\", 0,
					  NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS,
					  NULL, &res, NULL)==ERROR_SUCCESS)
  //   /,      
  {
		RegSetValueEx(res,"Number",0,REG_SZ, (BYTE*)LBStrg, strlen(LBStrg)+1);
		RegSetValueEx(res,"Mode",0, REG_BINARY, (BYTE*)&mode, 1);
		RegCloseKey(res); //   
  }
  else MessageBox("  ", "", MB_OK | MB_ICONHAND);
  TDialog::CmOk();
}
